<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="当前积分余额" prop="balance">
        <el-input v-model="formData.balance" placeholder="请输入当前积分余额" />
      </el-form-item>
      <el-form-item label="乐观锁版本号" prop="version">
        <el-input v-model="formData.version" placeholder="请输入乐观锁版本号" />
      </el-form-item>
      <el-form-item label="更新时间" prop="updatedAt">
        <el-date-picker
          v-model="formData.updatedAt"
          type="date"
          value-format="x"
          placeholder="选择更新时间"
        />
      </el-form-item>
      <el-form-item label="测试账户数量" prop="testAccountNum">
        <el-input v-model="formData.testAccountNum" placeholder="请输入测试账户数量" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { TenantBalanceApi, TenantBalance } from '@/api/keyboard/tenantbalance'

/** 租户余额 表单 */
defineOptions({ name: 'TenantBalanceForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  balance: undefined,
  version: undefined,
  updatedAt: undefined,
  testAccountNum: undefined
})
const formRules = reactive({
  balance: [{ required: true, message: '当前积分余额不能为空', trigger: 'blur' }],
  version: [{ required: true, message: '乐观锁版本号不能为空', trigger: 'blur' }],
  updatedAt: [{ required: true, message: '更新时间不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await TenantBalanceApi.getTenantBalance(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as TenantBalance
    if (formType.value === 'create') {
      await TenantBalanceApi.createTenantBalance(data)
      message.success(t('common.createSuccess'))
    } else {
      await TenantBalanceApi.updateTenantBalance(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    balance: undefined,
    version: undefined,
    updatedAt: undefined,
    testAccountNum: undefined
  }
  formRef.value?.resetFields()
}
</script>